'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _store = require('../store');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

const Script = (_ref) => {
  let {
    _name: name,
    _version: version,
    children
  } = _ref,
      props = _objectWithoutProperties(_ref, ['_name', '_version', 'children']);

  return _react2.default.createElement(
    _store.Consumer,
    null,
    ({ store }) => {
      if (name) {
        const attrs = { async: true, 'custom-element': name, src: store.getScriptSRC(name) };
        store.registerUniqueElement('script', attrs, name);
        return _react2.default.createElement(name, props, children);
      }
      store.registerElement('script', props);
      return children;
    }
  );
};

Script.defaultProps = {
  _name: '',
  _version: '',
  children: null,
  src: null
};

Script.propTypes = {
  _name: _propTypes2.default.string,
  _version: _propTypes2.default.string,
  children: _propTypes2.default.node,
  src: _propTypes2.default.string
};

exports.default = Script;
//# sourceMappingURL=Script.js.map