'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Link = require('./Link');

var _Link2 = _interopRequireDefault(_Link);

var _Meta = require('./Meta');

var _Meta2 = _interopRequireDefault(_Meta);

var _Script = require('./Script');

var _Script2 = _interopRequireDefault(_Script);

var _Tag = require('./Tag');

var _Tag2 = _interopRequireDefault(_Tag);

var _Title = require('./Title');

var _Title2 = _interopRequireDefault(_Title);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Transforms input to hyphened lowercase for each upper case coincidence.
 * @param {String} str React custom-element name e.g StickyAd
 * @returns {String} the input as kebabCase with leaded by a hyphen e.g. sticky-ad
 */
const toKebabCase = str => str.replace(/([A-Z])/g, '-$1').slice(1).toLowerCase();

function derivatedScriptComponent(name) {
  if (!/^[A-Z]/.test(name)) {
    throw Error(`Failed to fallback component name ${name}. Component to import must begin with uppercase.`);
  }
  return function scriptComponent(props) {
    return _react2.default.createElement(_Script2.default, _extends({
      _name: `amp-${toKebabCase(name)}`
    }, props));
  };
}

/**
 * @description Exposes a factory to generate AMP components in runtime.
 * @returns {Object} React component
 */
exports.default = new Proxy({
  Link: _Link2.default, Meta: _Meta2.default, Script: _Script2.default, Tag: _Tag2.default, Title: _Title2.default, toKebabCase
}, {
  get(thisModule, componentName) {
    return thisModule[componentName] || derivatedScriptComponent(componentName);
  }
});
//# sourceMappingURL=index.js.map